"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Breadcrumbs = Breadcrumbs;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _Link = require("../../../utils/Link");

function Breadcrumbs(props) {
  var items = props.items,
      className = props.className,
      collapseOnMobile = props.collapseOnMobile,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["items", "className", "collapseOnMobile"]);
  var breadcrumbs = items ? items.map(function (item, index) {
    var href = item.href,
        to = item.to,
        reactListKey = item.reactListKey,
        children = item.children,
        itemAttributes = (0, _objectWithoutProperties2["default"])(item, ["href", "to", "reactListKey", "children"]);
    return href || to ? /*#__PURE__*/_react["default"].createElement("li", {
      key: reactListKey || index,
      className: "govuk-breadcrumbs__list-item"
    }, /*#__PURE__*/_react["default"].createElement(_Link.Link, (0, _extends2["default"])({
      href: href,
      to: to,
      className: "govuk-breadcrumbs__link"
    }, itemAttributes), children)) : /*#__PURE__*/_react["default"].createElement("li", {
      key: reactListKey || index,
      className: "govuk-breadcrumbs__list-item",
      "aria-current": "page"
    }, children);
  }) : null;
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: "govuk-breadcrumbs ".concat(className || '', " ").concat(collapseOnMobile ? 'govuk-breadcrumbs--collapse-on-mobile' : '')
  }, attributes), /*#__PURE__*/_react["default"].createElement("ol", {
    className: "govuk-breadcrumbs__list"
  }, breadcrumbs));
}