"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CharacterCount = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _ = require("../..");

var CharacterCount = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var id = props.id,
      className = props.className,
      maxlength = props.maxlength,
      threshold = props.threshold,
      maxwords = props.maxwords,
      errorMessage = props.errorMessage,
      countMessage = props.countMessage,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["id", "className", "maxlength", "threshold", "maxwords", "errorMessage", "countMessage"]);
  var characterCountRef = (0, _react.useRef)();
  var characterCountInfoId = "".concat(id, "-info");
  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$import, CharacterCountJS;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof document !== 'undefined')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return import(
              /* webpackChunkName: "govuk-frontend-character-count" */

              /* webpackMode: "lazy" */

              /* webpackPrefetch: true */
              'govuk-frontend/govuk/components/character-count/character-count');

            case 3:
              _yield$import = _context.sent;
              CharacterCountJS = _yield$import["default"];

              if (characterCountRef.current) {
                new CharacterCountJS(characterCountRef.current).init();
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, [characterCountRef]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "govuk-character-count",
    "data-module": "govuk-character-count",
    "data-maxlength": maxlength,
    "data-threshold": threshold,
    "data-maxwords": maxwords,
    ref: characterCountRef
  }, /*#__PURE__*/_react["default"].createElement(_.Textarea, (0, _extends2["default"])({
    id: id
  }, attributes, {
    errorMessage: errorMessage,
    className: "govuk-js-character-count ".concat(className || '').concat(errorMessage ? ' govuk-textarea--error' : ''),
    "aria-describedby": characterCountInfoId,
    ref: ref
  })), /*#__PURE__*/_react["default"].createElement(_.Hint, {
    id: characterCountInfoId,
    className: "govuk-hint govuk-character-count__message ".concat((countMessage === null || countMessage === void 0 ? void 0 : countMessage.className) || ''),
    "aria-live": "polite"
  }, "You can enter up to ", maxlength || maxwords, ' ', maxwords ? 'words' : 'characters'));
});

exports.CharacterCount = CharacterCount;
CharacterCount.displayName = 'CharacterCount';