"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FileUpload = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _ = require("../..");

var FileUpload = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var className = props.className,
      errorMessage = props.errorMessage,
      formGroup = props.formGroup,
      hint = props.hint,
      label = props.label,
      describedBy = props['aria-describedby'],
      id = props.id,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["className", "errorMessage", "formGroup", "hint", "label", "aria-describedby", "id"]);
  var hintComponent;
  var errorMessageComponent;
  var describedByValue = describedBy || '';

  if (hint) {
    var hintId = "".concat(props.id, "-hint");
    describedByValue += " ".concat(hintId);
    hintComponent = /*#__PURE__*/_react["default"].createElement(_.Hint, (0, _extends2["default"])({}, props.hint, {
      id: hintId
    }));
  }

  if (errorMessage) {
    var errorId = "".concat(id, "-error");
    describedByValue += " ".concat(errorId);
    errorMessageComponent = /*#__PURE__*/_react["default"].createElement(_.ErrorMessage, (0, _extends2["default"])({}, errorMessage, {
      id: errorId
    }));
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "govuk-form-group".concat(errorMessage ? ' govuk-form-group--error' : '', " ").concat((formGroup === null || formGroup === void 0 ? void 0 : formGroup.className) || '')
  }, /*#__PURE__*/_react["default"].createElement(_.Label, (0, _extends2["default"])({}, label, {
    htmlFor: id
  })), hintComponent, errorMessageComponent, /*#__PURE__*/_react["default"].createElement("input", (0, _extends2["default"])({}, attributes, {
    id: id,
    ref: ref,
    className: "govuk-file-upload ".concat(className || '').concat(errorMessage ? ' govuk-file-upload--error' : ''),
    type: "file",
    "aria-describedby": describedByValue || null
  })));
});

exports.FileUpload = FileUpload;
FileUpload.displayName = 'FileUpload';