"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Label = Label;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

function Label(props) {
  var className = props.className,
      htmlFor = props.htmlFor,
      children = props.children,
      isPageHeading = props.isPageHeading,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["className", "htmlFor", "children", "isPageHeading"]); // If no children, just don't output anything

  if (!children) {
    return null;
  }

  var label =
  /*#__PURE__*/
  // Stop eslint flagging the for/id combination as an error. It is failing due to the way the
  // input and label are located in different components and so it cannot track the association
  //
  // eslint-disable-next-line jsx-a11y/label-has-for
  _react["default"].createElement("label", (0, _extends2["default"])({
    className: "govuk-label ".concat(className || '')
  }, attributes, {
    htmlFor: htmlFor
  }), children);

  if (isPageHeading === true) {
    return /*#__PURE__*/_react["default"].createElement("h1", {
      className: "govuk-label-wrapper"
    }, label);
  }

  return label;
}