"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NotificationBanner = NotificationBanner;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

function NotificationBanner(props) {
  var type = props.type,
      titleChildren = props.titleChildren,
      titleHeadingLevel = props.titleHeadingLevel,
      children = props.children,
      className = props.className,
      titleId = props.titleId,
      role = props.role,
      disableAutoFocus = props.disableAutoFocus,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["type", "titleChildren", "titleHeadingLevel", "children", "className", "titleId", "role", "disableAutoFocus"]);
  var notificationBannerRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$import, NotificationBannerJS;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof document !== 'undefined')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return import(
              /* webpackChunkName: "govuk-frontend-notification-banner" */

              /* webpackMode: "lazy" */

              /* webpackPrefetch: true */
              'govuk-frontend/govuk/components/notification-banner/notification-banner');

            case 3:
              _yield$import = _context.sent;
              NotificationBannerJS = _yield$import["default"];

              if (notificationBannerRef.current) {
                new NotificationBannerJS(notificationBannerRef.current).init();
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, [notificationBannerRef]);
  var HeadingLevel = titleHeadingLevel ? "h".concat(titleHeadingLevel) : 'h2';
  var successBanner = false;

  if (type === 'success') {
    successBanner = true;
  }

  var typeClass = '';

  if (successBanner) {
    typeClass = "govuk-notification-banner--".concat(type);
  }

  var roleAttribute = 'region';

  if (role) {
    roleAttribute = role;
  } else if (successBanner) {
    roleAttribute = 'alert';
  }

  var title = titleChildren;

  if (!titleChildren) {
    if (successBanner) {
      title = 'Success';
    } else {
      title = 'Important';
    }
  }

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: "govuk-notification-banner ".concat(typeClass, " ").concat(className || ''),
    role: roleAttribute,
    "aria-labelledby": titleId,
    "data-module": "govuk-notification-banner",
    ref: notificationBannerRef
  }, disableAutoFocus ? {
    'data-disable-auto-focus': 'true'
  } : {}, attributes), /*#__PURE__*/_react["default"].createElement("div", {
    className: "govuk-notification-banner__header"
  }, /*#__PURE__*/_react["default"].createElement(HeadingLevel, {
    className: "govuk-notification-banner__title",
    id: titleId
  }, title)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "govuk-notification-banner__content"
  }, typeof children === 'string' ? /*#__PURE__*/_react["default"].createElement("p", {
    className: "govuk-notification-banner__heading"
  }, children) : children));
}

NotificationBanner.defaultProps = {
  titleId: 'govuk-notification-banner-title'
};