"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _ = require("../..");

var Select = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var className = props.className,
      describedBy = props['aria-describedby'],
      errorMessage = props.errorMessage,
      formGroup = props.formGroup,
      hint = props.hint,
      id = props.id,
      items = props.items,
      label = props.label,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["className", "aria-describedby", "errorMessage", "formGroup", "hint", "id", "items", "label"]);
  var describedByValue = describedBy || '';
  var hintComponent;
  var errorMessageComponent;

  if (hint) {
    var hintId = "".concat(id, "-hint");
    describedByValue += " ".concat(hintId);
    hintComponent = /*#__PURE__*/_react["default"].createElement(_.Hint, (0, _extends2["default"])({}, hint, {
      id: hintId
    }));
  }

  if (errorMessage) {
    var errorId = id ? "".concat(id, "-error") : '';
    describedByValue += " ".concat(errorId);
    errorMessageComponent = /*#__PURE__*/_react["default"].createElement(_.ErrorMessage, (0, _extends2["default"])({}, errorMessage, {
      id: errorId
    }));
  }

  var options = items ? items.filter(function (item) {
    return item;
  }).map(function (option, index) {
    var reactListKey = option.reactListKey,
        children = option.children,
        optionAttributes = (0, _objectWithoutProperties2["default"])(option, ["reactListKey", "children"]);
    return /*#__PURE__*/_react["default"].createElement("option", (0, _extends2["default"])({}, optionAttributes, {
      key: reactListKey || index
    }), children);
  }) : null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "govuk-form-group".concat(errorMessage ? ' govuk-form-group--error' : '', " ").concat((formGroup === null || formGroup === void 0 ? void 0 : formGroup.className) || '')
  }, /*#__PURE__*/_react["default"].createElement(_.Label, (0, _extends2["default"])({}, label, {
    htmlFor: id
  })), hintComponent, errorMessageComponent, /*#__PURE__*/_react["default"].createElement("select", (0, _extends2["default"])({
    className: "govuk-select ".concat(className || '').concat(errorMessage ? ' govuk-select--error' : ''),
    id: id,
    ref: ref,
    "aria-describedby": describedByValue || null
  }, attributes), options));
});

exports.Select = Select;
Select.displayName = 'Select';