"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs = Tabs;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

function Tabs(props) {
  var className = props.className,
      id = props.id,
      idPrefix = props.idPrefix,
      items = props.items,
      title = props.title,
      attributes = (0, _objectWithoutProperties2["default"])(props, ["className", "id", "idPrefix", "items", "title"]);
  var tabsRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$import, TabsJS;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof document !== 'undefined')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return import(
              /* webpackChunkName: "govuk-frontend-tabs" */

              /* webpackMode: "lazy" */

              /* webpackPrefetch: true */
              'govuk-frontend/govuk/components/tabs/tabs');

            case 3:
              _yield$import = _context.sent;
              TabsJS = _yield$import["default"];

              if (tabsRef.current) {
                new TabsJS(tabsRef.current).init();
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, [tabsRef]);
  var filteredItems = items ? items.filter(function (item) {
    return item;
  }) : [];
  var tabContent = filteredItems.map(function (item, index) {
    // eslint-disable-next-line no-unused-vars
    var itemId = item.id,
        label = item.label,
        panel = item.panel,
        itemAttributes = (0, _objectWithoutProperties2["default"])(item, ["id", "label", "panel"]);
    var tabId = "".concat(itemId || "".concat(idPrefix, "-").concat(index + 1));
    return /*#__PURE__*/_react["default"].createElement("li", {
      key: tabId,
      className: "govuk-tabs__list-item".concat(index === 0 ? ' govuk-tabs__list-item--selected' : '')
    }, /*#__PURE__*/_react["default"].createElement("a", (0, _extends2["default"])({
      className: "govuk-tabs__tab",
      href: "#".concat(tabId)
    }, itemAttributes), label));
  });
  var tabs = filteredItems.length > 0 ? /*#__PURE__*/_react["default"].createElement("ul", {
    className: "govuk-tabs__list"
  }, tabContent) : null;
  var panels = filteredItems.map(function (item, index) {
    // eslint-disable-next-line no-unused-vars
    var itemId = item.id,
        panel = item.panel,
        label = item.label,
        itemAttributes = (0, _objectWithoutProperties2["default"])(item, ["id", "panel", "label"]);
    var panelId = "".concat(itemId || "".concat(idPrefix, "-").concat(index + 1));
    return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      key: panelId,
      className: "govuk-tabs__panel".concat(index > 0 ? ' govuk-tabs__panel--hidden' : ''),
      id: panelId
    }, panel));
  });
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    id: id,
    className: "govuk-tabs ".concat(className || '')
  }, attributes, {
    "data-module": "govuk-tabs",
    ref: tabsRef
  }), /*#__PURE__*/_react["default"].createElement("h2", {
    className: "govuk-tabs__title"
  }, title), tabs, panels);
}

Tabs.defaultProps = {
  title: 'Contents',
  idPrefix: ''
};